;///////////////////////////;
;                           ;
;    Pong game by JeePee    ;
;    made for contest       ;
;                           ;
;///////////////////////////;
.nolist
#define   TI83P
#define   bcall(xxxx)    rst 28h \ .dw xxxx
#include  "ion.inc"
.list

     .org $9d93
     .db $BB,$6D
     ret
     jr   nc,Start
     .db  "<BETA> Pong-4 by JeePee",0


_lcd_busy_quick  = $000B
_eraseEOL        = $4552

batx = appbackupscreen
baty = batx + 1
ballx = baty + 1
bally = ballx + 1
hdir = bally + 1    ;-1 = left ; 1 = right
vdir = hdir + 1     ;-1 = up   ; 1 = down
score = vdir + 1
ballcounter = score + 1  ;delay for the ball, otherwise it's to fast!
initvalue = ballcounter + 1   ;initial value for the graphbuffer (inverted or not)
curcontrast = $8447           ;place where the current contrast is saved

Start:
     ld   hl,$1C2B
     ld   (batx),hl      ;center bat...
     ld   (ballx),hl     ;... and ball on the screen
     ld   hl,$0101
     ld   (hdir),hl      ;set the initial direction, because random you are never in time to pong the ball!
     ld   hl,$0000
     ld   (score),hl     ;reset the score
     ld   (ballcounter),hl    ;reset the ballcounter (the delay for the ball)
     ld   (initvalue),hl      ;at start, the screen isn't inversed
     ld   a,$FD          ;contrast 39
     out  ($10),a
;     ld   a,37
;     ld   (contrast),a
mainloop:
     call fillgraphini
     ld   ix,pleftright
     ld   b,16
     ld   a,(baty)
     ld   l,a
     xor  a
     call ionPutSprite   ;drawleftbat
     ld   ix,pleftright
     ld   b,16
     ld   a,(baty)
     ld   l,a
     ld   a,93
     call ionPutSprite   ;draw rightbat
     ld   b,3
     xor  a
     ld   l,a
     ld   a,(batx)
     call ionPutSprite   ;draw left side upbat
     ld   b,3
     xor  a
     ld   l,a
     ld   a,(batx)
     add  a,8
     call ionPutSprite   ;draw right side upbat
     ld   ix,pupdown
     ld   b,3
     ld   a,61
     ld   l,a
     ld   a,(batx)
     call ionPutSprite   ;draw left side downbat
     ld   b,3
     ld   a,61
     ld   l,a
     ld   a,(batx)
     add  a,8
     call ionPutSprite   ;draw right side downbat
     ld   b,4
     ld   a,(bally)
     ld   l,a
     ld   a,(ballx)
     call ionPutSprite   ;draw ball
     call ionFastCopy    ;copy graphbuffer to screen
     ;check arrowpad
     xor  a
     out  (1),a          ;clear the buffer
     ld   a,%11111110    ;check group 1  =>  bit 0 = 0
     out  (1),a
     in   a,(1)
     bit  3,a
     jr   z,batup
     bit  2,a
     jr   z,batright
     bit  1,a
     jr   z,batleft
     bit  0,a
     jr   z,batdown
     ;check clearkey
     xor  a
     out  (1),a          ;clear the buffer
     ld   a,%11111101    ;check group 2 =>  bit 1 = 0
     out  (1),a
     in   a,(1)
     bit  6,a
     jr   nz,moveball
     ret                 ;pressed clear: stop the game!
     
batdown:
     ld   a,(baty)
     cp   45
     jr   z,moveball     ;we're already on the bottom of the screen
     inc  a
     ld   (baty),a
     jr   moveball
batup:
     ld   a,(baty)
     cp   3
     jr   z,moveball     ;we're on the top of the screen, we won't go further
     dec  a
     ld   (baty),a
     jr   moveball
batleft:
     ld   a,(batx)
     cp   3              ;we can't go to the right anymore...
     jp   z,moveball
     dec  a
     ld   (batx),a
     jr   moveball
batright:
     ld   a,(batx)
     cp   77             ;we're on the most right of the screen
     jp   z,moveball
     inc  a
     ld   (batx),a
     ;jr  moveball

moveball:
     ld   a,(ballcounter)     ;a small delay: otherwise you wont be able to play the ball even twice! :)
     xor  1                   ;each other time you the ball may go furhter  => xor 1
     ld   (ballcounter),a
     jp   nz,mainloop
     ld   a,(hdir)       ;-1=left  ;  1=right
     ld   b,a
     ld   a,(ballx)
     add  a,b            ;we add it!
     ld   (ballx),a
     cp   2              ;at the left;
     jp   z,bounceright
     cp   90
     jp   z,bounceleft
checkv:
     ld   a,(vdir)
     ld   b,a
     ld   a,(bally)
     add  a,b
     ld   (bally),a
     cp   2
     jr   z,bouncedown
     cp   58
     jp   nz,mainloop
     
bouncedown:
bounceup:
     ld   hl,ballx       ;ld the pointer of ballx in hl, good for the checkdeath routine...
     call checkdeath
     ld   a,(vdir)       ;reverse the vertical direction: xor 11111110  =>  -1 -> 1 ; 1 -> -1
     xor  %11111110
     ld   (vdir),a
     jp   mainloop
bounceright:
bounceleft:
     ld   hl,bally       ;ld the pointer of bally in hl, good for the checkdeath routine...
     call checkdeath
     ld   a,(hdir)       ;reverse the horizontal direction: xor 11111110  =>  -1 -> 1 ; 1 -> -1
     xor  %11111110
     ld   (hdir),a
     jr   checkv
     
;-----= Routines =-----;
checkdeath:
     ld   a,(hl)         ;get the ballx / bally value into register b
     ld   b,a
     dec  hl             ;we increase 2 times, so we come out to batx if a was ballx, and baty if a was bally
     dec  hl
     ld   a,(hl)         ;get the batx / baty value
     dec  a              ;a little correction for the left-/upside
     dec  a
     cp   b
     jr   nc,death       ;is the ball left / up the bat?
     add  a,16           ;check the right-/downside
     cp   b
     jr   c,death        ;is the ball right / down the bat?
     
     ld   hl,score       ;update the score each time you bump to a bat
     inc  (hl)
     
     ld   a,15           ;each 16 points inverse the screen
     and  (hl)
     jr   nz,noinverse
     ld   a,(initvalue)
     xor  $FF            ;00->FF ; FF->00
     ld   (initvalue),a
     ld   a,(contrast)   ;modify the contrast, so the sight is better
     xor  5              ;37 -> 32; 32 -> 37
;     ld   (curcontrast),a
     add  a,$D8          ;contrast + ($18 or $C0)
     out  (10h),a
noinverse:
     ret
death:
     pop  hl             ;we did a call, so we pop up the stack once, so we can exit the program with a ret
     ld   hl,$0003
     ld   (currow),hl
     ld   hl,txtlose
     bcall(_puts)
     ld   hl,(score)
     ld   h,0
     bcall(_disphl)      ;display the score in a right aligned field of five characters (_disphl)
getkeyloop:
     bcall(_getkey)
     cp   $05            ;check for enter
     jr   nz,getkeyloop     
     ret                 ;return from the program

fillgraphini:            ;fill the grapgbuffer with a value
     ld   hl,grbuf       ;because the sprite routines are xor-ed ...
     ld   de,grbuf+1     ;.. $FF will invert, and $00 will display normal!
     ld   bc,768
     ld   a,(initvalue)  ;$FF or $00
     ld   (hl),a
     ldir
     ret

cpdehl:
     
;-----= Data =-----;
highscore:
     .db 0
;-----= Text =-----;
txtlose:
     .db "Your score:",0
;-----= Sprites =-----;
pleftright:
     .db %11100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %10100000
     .db %11100000
pupdown:
     .db %11111111
     .db %10000000
     .db %11111111

     .db %11111111
     .db %00000001
     .db %11111111
ball:
     .db %01100000
     .db %11110000
     .db %11110000
     .db %01100000
.end
.end